
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Quiz_choicesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quiz_choices = await db.quiz_choices.create(
            {
                id: data.id || undefined,
        
        choice_text: data.choice_text
        ||
        null
            ,
            
        is_correct: data.is_correct
        ||
        false
        
            ,
            
        sequence_order: data.sequence_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await quiz_choices.setQuiz_question( data.quiz_question || null, {
            transaction,
        });
        
        await quiz_choices.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return quiz_choices;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const quiz_choicesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                choice_text: item.choice_text
            ||
            null
            ,
            
                is_correct: item.is_correct
            ||
            false
        
            ,
            
                sequence_order: item.sequence_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const quiz_choices = await db.quiz_choices.bulkCreate(quiz_choicesData, { transaction });

        // For each item created, replace relation files
        

        return quiz_choices;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const quiz_choices = await db.quiz_choices.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.choice_text !== undefined) updatePayload.choice_text = data.choice_text;
        
        
        if (data.is_correct !== undefined) updatePayload.is_correct = data.is_correct;
        
        
        if (data.sequence_order !== undefined) updatePayload.sequence_order = data.sequence_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await quiz_choices.update(updatePayload, {transaction});

        
        
        if (data.quiz_question !== undefined) {
            await quiz_choices.setQuiz_question(
              
              data.quiz_question,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await quiz_choices.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return quiz_choices;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quiz_choices = await db.quiz_choices.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of quiz_choices) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of quiz_choices) {
                await record.destroy({transaction});
            }
        });


        return quiz_choices;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const quiz_choices = await db.quiz_choices.findByPk(id, options);

        await quiz_choices.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await quiz_choices.destroy({
            transaction
        });

        return quiz_choices;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const quiz_choices = await db.quiz_choices.findOne(
            { where },
            { transaction },
        );

        if (!quiz_choices) {
            return quiz_choices;
        }

        const output = quiz_choices.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.quiz_question = await quiz_choices.getQuiz_question({
            transaction
        });
        
        
        output.organizations = await quiz_choices.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.quiz_questions,
        as: 'quiz_question',
        
        where: filter.quiz_question ? {
          [Op.or]: [
            { id: { [Op.in]: filter.quiz_question.split('|').map(term => Utils.uuid(term)) } },
            {
              prompt: {
                [Op.or]: filter.quiz_question.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.choice_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'quiz_choices',
                        'choice_text',
                        filter.choice_text,
                    ),
                };
            }
            

            
            

            
            if (filter.sequence_orderRange) {
                const [start, end] = filter.sequence_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sequence_order: {
                    ...where.sequence_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sequence_order: {
                    ...where.sequence_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_correct) {
                where = {
                    ...where,
                is_correct: filter.is_correct,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.quiz_choices.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'quiz_choices',
                        'choice_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.quiz_choices.findAll({
            attributes: [ 'id', 'choice_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['choice_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.choice_text,
        }));
    }

    
};

